<?php
/* Product Delivery Date for WooCommerce - Lite support functions
------------------------------------------------------------------------------- */

// Theme init priorities:
// 9 - register other filters (for installer, etc.)
if (!function_exists('giardino_pdd_theme_setup9')) {
	add_action( 'after_setup_theme', 'giardino_pdd_theme_setup9', 9 );
	function giardino_pdd_theme_setup9() {
		if (is_admin()) {
			add_filter( 'giardino_filter_tgmpa_required_plugins',			'giardino_pdd_tgmpa_required_plugins' );
		}
	}
}

// Filter to add in the required plugins list
if ( !function_exists( 'giardino_pdd_tgmpa_required_plugins' ) ) {
	function giardino_pdd_tgmpa_required_plugins($list=array()) {
		if (giardino_storage_isset('required_plugins', 'product-delivery-date')) {
			// CF7 plugin
			$list[] = array(
					'name' 		=> giardino_storage_get_array('required_plugins', 'product-delivery-date'),
					'slug' 		=> 'product-delivery-date-for-woocommerce-lite',
					'required' 	=> false
			);
		}
		return $list;
	}
}



// Check if pdd installed and activated
if ( !function_exists( 'giardino_exists_pdd' ) ) {
	function giardino_exists_pdd() {
        return class_exists( 'Prdd_Lite_Woocommerce' );
	}
}
?>