<?php
/* Table Reservation support functions
------------------------------------------------------------------------------- */

// Theme init priorities:
// 9 - register other filters (for installer, etc.)
if ( ! function_exists( 'giardino_table_reservation_theme_setup9' ) ) {
    add_action( 'after_setup_theme', 'giardino_table_reservation_theme_setup9', 9 );
    function giardino_table_reservation_theme_setup9() {

        if ( is_admin() ) {
            add_filter( 'giardino_filter_tgmpa_required_plugins', 'giardino_table_reservation_tgmpa_required_plugins' );
        }
        if ( !is_admin() && class_exists( 'TREMTableReservation' ) ) { 
            global $tremtr_controller;
            remove_action( 'init', array( $tremtr_controller->settings, 'load_settings_panel' ) );
        }
    }
}

// Filter to add in the required plugins list
if ( ! function_exists( 'giardino_table_reservation_tgmpa_required_plugins' ) ) {
    
    function giardino_table_reservation_tgmpa_required_plugins( $list = array() ) {
        if ( giardino_storage_isset( 'required_plugins', 'table-reservation' ) && giardino_is_theme_activated() ) {
            $path = giardino_get_plugin_source_path( 'plugins/table-reservation/table-reservation.zip' );
            if ( ! empty( $path ) || giardino_get_theme_setting( 'tgmpa_upload' ) ) {
                $list[] = array(
                    'name'     => giardino_storage_get_array( 'required_plugins', 'table-reservation' ),
                    'slug'     => 'table-reservation',
                    'source'   => ! empty( $path ) ? $path : 'upload://table-reservation.zip',
                    'version'  => '4.0.3',
                    'required' => false,
                );
            }
        }
        return $list;
    }
}

// Check if this plugin installed and activated
if ( ! function_exists( 'giardino_exists_table_reservation' ) ) {
	function giardino_exists_table_reservation() {
		return class_exists( 'TREMTableReservation' );
	}
}

// Set plugin's specific importer options
if ( !function_exists( 'giardino_table_reservation_importer_set_options' ) ) {
    if (is_admin()) add_filter( 'trx_addons_filter_importer_options',    'giardino_table_reservation_importer_set_options' );
    function giardino_table_reservation_importer_set_options($options=array()) {   
        if ( giardino_exists_table_reservation() && in_array('table-reservation', $options['required_plugins']) ) {
            $options['additional_options'][]    = 'tremtr-settings';                    // Add slugs to export options for this plugin
        }
        return $options;
    }
}


if ( ! function_exists( 'giardino_table_reservation_add_admin_menu_separator' ) ) {
    add_action( 'admin_init', 'giardino_table_reservation_add_admin_menu_separator', 9 );
    function giardino_table_reservation_add_admin_menu_separator() {
        global $menu;
        if (!is_array($menu) && empty($menu)) {
                $menu = array();
        }
    }
}