<?php
// Add plugin-specific colors and fonts to the custom CSS
if ( ! function_exists( 'giardino_tribe_events_get_css' ) ) {
	add_filter( 'giardino_filter_get_css', 'giardino_tribe_events_get_css', 10, 2 );
	function giardino_tribe_events_get_css( $css, $args ) {
		if ( isset( $css['fonts'] ) && isset( $args['fonts'] ) ) {
			$fonts         = $args['fonts'];
			$css['fonts'] .= <<<CSS
			
.tribe-events-list .tribe-events-list-event-title,
.single-tribe_events #tribe-events-content .tribe-events-event-meta dd,
.single-tribe_events #tribe-events-content .tribe-events-event-meta dt {
	{$fonts['h3_font-family']}
}

#tribe-events .tribe-events-button,
.tribe-events-button,
.tribe-events-cal-links a,
.tribe-events-sub-nav li a,
.tribe-events .tribe-events-c-ical__link,
.tribe-events-c-nav__list .tribe-events-c-nav__list-item button.tribe-events-c-nav__prev,
.tribe-events-c-nav__list .tribe-events-c-nav__list-item button.tribe-events-c-nav__next,
.tribe-events-c-nav__list .tribe-events-c-nav__list-item a.tribe-events-c-nav__prev,
.tribe-events-c-nav__list .tribe-events-c-nav__list-item a.tribe-events-c-nav__next {
	{$fonts['button_font-family']}
	{$fonts['button_font-size']}
	{$fonts['button_font-weight']}
	{$fonts['button_font-style']}
	{$fonts['button_line-height']}
	{$fonts['button_text-decoration']}
	{$fonts['button_text-transform']}
	{$fonts['button_letter-spacing']}
}
#tribe-bar-form button, #tribe-bar-form a,
.tribe-events-read-more {
	{$fonts['button_font-family']}
	{$fonts['button_letter-spacing']}
}
.tribe-events-list .tribe-events-list-separator-month,
.tribe-events-calendar thead th,
.tribe-events-schedule, .tribe-events-schedule h2 {
	{$fonts['h5_font-family']}
}
#tribe-bar-form input, #tribe-events-content.tribe-events-month,
#tribe-events-content .tribe-events-calendar div[id*="tribe-events-event-"] h3.tribe-events-month-event-title,
#tribe-mobile-container .type-tribe_events,
.tribe-events-list-widget ol li .tribe-event-title,
.tribe-events-single>.tribe_events>:not(.primary,.secondary,.tribe-events-related-events-title,.tribe-related-events) {
	{$fonts['p_font-family']}
	{$fonts['p_line-height']}
}
.tribe-events-content p {
	{$fonts['p_font-size']}
}
.tribe-events-loop .tribe-event-schedule-details,
.single-tribe_events #tribe-events-content .tribe-events-event-meta dt,
#tribe-mobile-container .type-tribe_events .tribe-event-date-start {
	{$fonts['info_font-family']};
}

.tribe-common .tribe-common-h4,
.tribe-common .tribe-common-b3,
.tribe-common .tribe-common-c-btn-border,
.tribe-common a.tribe-common-c-btn-border,
.tribe-events .tribe-events-c-view-selector__list-item-text,
.tribe-common .tribe-common-c-btn,
.tribe-common a.tribe-common-c-btn,
.tribe-common .tribe-common-b2,
.tribe-common .tribe-common-h7,
.tribe-common .tribe-common-h8,
.tribe-common .tribe-common-h2,
.tribe-common .tribe-common-h3,
.tribe-common .tribe-common-h5,
.tribe-common .tribe-common-h6,
.tribe-common .tribe-events-c-events-bar__search .tribe-common-form-control-text__input,
.tribe-events .tribe-events-calendar-month__calendar-event-tooltip-datetime,
.tribe-events .datepicker .datepicker-switch, .tribe-events .datepicker .month, .tribe-events .datepicker .year,
.tribe-events .tribe-events-calendar-list__event-date-tag-weekday{
	{$fonts['p_font-family']}
}

.tribe-common .tribe-common-c-btn, .tribe-common a.tribe-common-c-btn, .tribe-common button.tribe-common-c-btn,
.tribe-common.tribe-events .tribe-events-c-top-bar__today-button{
    {$fonts['button_font-family']}
}


CSS;
		}

		if ( isset( $css['vars'] ) && isset( $args['vars'] ) ) {
			$vars         = $args['vars'];
			$css['vars'] .= <<<CSS

#tribe-bar-form .tribe-bar-submit input[type="submit"],
#tribe-bar-form button,
#tribe-bar-form a,
#tribe-events .tribe-events-button,
#tribe-bar-views .tribe-bar-views-list,
.tribe-events-button,
.tribe-events-cal-links a,
#tribe-events-footer ~ a.tribe-events-ical.tribe-events-button,
.tribe-events-sub-nav li a {
	-webkit-border-radius: {$vars['rad']};
	    -ms-border-radius: {$vars['rad']};
			border-radius: {$vars['rad']};
}

CSS;
		}

		if ( isset( $css['colors'] ) && isset( $args['colors'] ) ) {
			$colors         = $args['colors'];
			$css['colors'] .= <<<CSS

/* Filters bar */
#tribe-bar-form {
	color: {$colors['text_dark']};
}
#tribe-bar-form input[type="text"] {
	color: {$colors['text_dark']};
	border-color: {$colors['bd_color']};
}
#tribe-bar-form input[type="text"]:focus{
    border-color: {$colors['text_dark']};
}
.tribe-bar-views-list li, #tribe-bar-form.tribe-bar-collapse .tribe-bar-filters {
	background-color: {$colors['alter_bg_hover']};
}
#tribe-bar-form .tribe-bar-views-list li.tribe-bar-views-option:not(:first-child) a{
    color: {$colors['extra_dark']};
}

#tribe-bar-views .tribe-bar-views-list .tribe-bar-views-option a:hover,
.tribe-bar-mini #tribe-bar-views .tribe-bar-views-list .tribe-bar-views-option a:hover {
    background-color: {$colors['text_link']};
    color: {$colors['extra_dark']};
}
.datepicker thead tr:first-child th:hover, .datepicker tfoot tr th:hover {
	color: {$colors['text_link']};
	background: {$colors['text_dark']};
}
#tribe-bar-collapse-toggle:focus, #tribe-bar-collapse-toggle:hover{
    color: {$colors['text_dark']};
}
/* Content */
.tribe-events-calendar thead th {
	color: {$colors['extra_dark']};
	background: {$colors['extra_bg_color']} !important;
}
.tribe-events-calendar thead th + th:before {
	background: {$colors['extra_dark']};
}
#tribe-events-content .tribe-events-calendar td {
	border-color: {$colors['bd_color']} !important;
}
.tribe-events-calendar td div[id*="tribe-events-daynum-"]{
    color: {$colors['text_link']};
    background: {$colors['alter_bg_hover']};
}
.tribe-events-calendar td:hover div[id*="tribe-events-daynum-"]{
    color: {$colors['extra_dark']};
    background: {$colors['text_link']};
}
 table.tribe-events-calendar > tbody > tr > td, table.tribe-events-calendar > tbody > tr:nth-child(2n) > td  {
   background: {$colors['bg_color']};
 }
.tribe-events-calendar td div[id*="tribe-events-daynum-"] > a {
	color: {$colors['text_dark']};
}
.tribe-events-calendar td.tribe-events-othermonth {
	color: {$colors['alter_light']};
	background: transparent!important;
}
.tribe-events-calendar td.tribe-events-othermonth div[id*="tribe-events-daynum-"]{
    color: {$colors['text_dark']};
}
.tribe-events-calendar td.tribe-events-othermonth div[id*="tribe-events-daynum-"] > a {
	color: {$colors['text_link']};
}
.tribe-events-calendar td.tribe-events-past div[id*="tribe-events-daynum-"]{
    color: {$colors['text_dark']};
}
.tribe-events-calendar td.tribe-events-past div[id*="tribe-events-daynum-"] > a {
	color: {$colors['text_light']};
}
.tribe-events-calendar td.tribe-events-present div[id*="tribe-events-daynum-"]{
    color: {$colors['extra_dark']};
    background: {$colors['text_link']};
    
}
.tribe-events-calendar td.tribe-events-present div[id*="tribe-events-daynum-"] > a {
	color: {$colors['text_link']};
}

#tribe-bar-views .tribe-bar-views-list .tribe-bar-views-option:first-child > a span:before{
    background: {$colors['text_dark']};
}
.tribe-events-calendar td.tribe-events-present:before {
	border-color: {$colors['text_link']};
}
.tribe-events-calendar .tribe-events-has-events:after {
	background-color: {$colors['text']};
}
.tribe-events-calendar .mobile-active.tribe-events-has-events:after {
	background-color: {$colors['text_link']};
}
#tribe-events-content .tribe-events-calendar td,
#tribe-events-content .tribe-events-calendar div[id*="tribe-events-event-"] h3.tribe-events-month-event-title a {
	color: {$colors['text_dark']};
}
#tribe-events-content .tribe-events-calendar div[id*="tribe-events-event-"] h3.tribe-events-month-event-title a:hover {
	color: {$colors['text_link']};
}
#tribe-events-content .tribe-events-calendar td.mobile-active,
#tribe-events-content .tribe-events-calendar td.mobile-active:hover {
	color: {$colors['inverse_link']};
	background-color: transparent;
}

#tribe-events-content .tribe-events-calendar td.mobile-active div[id*="tribe-events-daynum-"] {
	color: {$colors['bg_color']};
	background-color: {$colors['text_dark']};
}
#tribe-events-content .tribe-events-calendar td.tribe-events-othermonth.mobile-active div[id*="tribe-events-daynum-"] a,
.tribe-events-calendar .mobile-active div[id*="tribe-events-daynum-"] a {
	background-color: transparent;
	color: {$colors['bg_color']};
}
.events-archive.events-gridview #tribe-events-content table .type-tribe_events {
	border-color: {$colors['bd_color']};
}

/* Tooltip */
.recurring-info-tooltip,
.tribe-events-calendar .tribe-events-tooltip,
.tribe-events-week .tribe-events-tooltip,
.tribe-events-tooltip .tribe-events-arrow {
	color: {$colors['alter_text']};
	background: {$colors['alter_bg_color']};
    
}
.tribe-events-calendar .tribe-events-tooltip{
    border-color: {$colors['alter_bg_color']};
}
#tribe-events-content .tribe-events-tooltip .summary { 
	color: {$colors['extra_dark']};
	background: {$colors['extra_bg_color']};
}
.tribe-events-tooltip .tribe-event-duration {
	color: {$colors['text_dark']};
}

/* Events list */
.tribe-events-list-separator-month {
	color: {$colors['text_dark']};
}
.tribe-events-list-separator-month:after {
	border-color: {$colors['bd_color']};
}

.tribe-events-list .type-tribe_events + .type-tribe_events,
.tribe-events-day .tribe-events-day-time-slot + .tribe-events-day-time-slot + .tribe-events-day-time-slot {
	border-color: {$colors['bd_color']};
}
.tribe-events-list .tribe-events-event-cost span {
	color: {$colors['extra_dark']};
	border-color: {$colors['extra_bg_color']};
	background: {$colors['extra_bg_color']};
}
.tribe-mobile .tribe-events-loop .tribe-events-event-meta {
	color: {$colors['alter_text']};
	border-color: {$colors['alter_bd_color']};
}
.tribe-mobile .tribe-events-loop .tribe-events-event-meta a {
	color: {$colors['alter_link']};
}
.tribe-mobile .tribe-events-loop .tribe-events-event-meta a:hover {
	color: {$colors['alter_hover']};
}
.tribe-mobile .tribe-events-list .tribe-events-venue-details {
	border-color: {$colors['alter_bd_color']};
}

.single-tribe_events #tribe-events-footer,
.tribe-events-day #tribe-events-footer,
.events-list #tribe-events-footer,
.tribe-events-map #tribe-events-footer,
.tribe-events-photo #tribe-events-footer {
	border-color: {$colors['bd_color']};	
}
/* Events day */
.tribe-events-day .tribe-events-day-time-slot h5 {
	color: {$colors['bg_color']};
	background: {$colors['text_dark']};
}

/* Single Event */
.single-tribe_events .tribe-events-venue-map {
	color: {$colors['alter_text']};
	border-color: {$colors['alter_bd_hover']};
	background: {$colors['alter_bg_hover']};
}
.single-tribe_events .tribe-events-schedule .tribe-events-cost {
	color: {$colors['text_dark']};
}
.single-tribe_events .type-tribe_events {
	border-color: {$colors['bd_color']};
}

.tribe-events .tribe-events-c-ical__link{
    color: {$colors['inverse_link']};
}
.tribe-common--breakpoint-medium.tribe-common .tribe-common-h3{
     color: {$colors['text_hover']};
}
.tribe-common--breakpoint-medium.tribe-common .tribe-common-h3:hover{
     color: {$colors['text_dark']}!important;
}
.tribe-events .tribe-events-calendar-month__day--current .tribe-events-calendar-month__day-date,
.tribe-events .tribe-events-calendar-month__day--current .tribe-events-calendar-month__day-date-link{
    color: {$colors['text_hover']};
}
.tribe-common .tribe-common-h4{
    color: {$colors['text_dark']};
}
.tribe-common--breakpoint-medium.tribe-common .tribe-common-c-btn.tribe-events-c-search__button,
.tribe-events .tribe-events-c-ical__link{
    border-color: {$colors['text_dark']};
    color: {$colors['text_dark']};
}
.tribe-common--breakpoint-medium.tribe-common .tribe-common-c-btn.tribe-events-c-search__button:hover{
     color: {$colors['text_dark']};
}
.tribe-common .tribe-common-c-loader .tribe-common-c-loader__dot {
    background-color: {$colors['text_hover']};
}
.tribe-events .tribe-events-calendar-month__multiday-event-bar-inner{
    background-color: {$colors['alter_bg_color']}!important;
}
.tribe-events .datepicker .day.active,
.tribe-events .datepicker .day.active.focused,
.tribe-events .datepicker .day.active:focus,
.tribe-events .datepicker .day.active:hover,
.tribe-events .datepicker .month.active,
.tribe-events .datepicker .month.active.focused,
.tribe-events .datepicker .month.active:focus,
.tribe-events .datepicker .month.active:hover,
.tribe-events .datepicker .year.active,
.tribe-events .datepicker .year.active.focused,
.tribe-events .datepicker .year.active:focus,
.tribe-events .datepicker .year.active:hover{
      background-color: {$colors['extra_bg_color']}
}
.tribe-events .datepicker .day.current, 
.tribe-events .datepicker .day.current.focused, 
.tribe-events .datepicker .day.current:focus, 
.tribe-events .datepicker .day.current:hover, 
.tribe-events .datepicker .month.current, 
.tribe-events .datepicker .month.current.focused, 
.tribe-events .datepicker .month.current:focus, 
.tribe-events .datepicker .month.current:hover, 
.tribe-events .datepicker .year.current, 
.tribe-events .datepicker .year.current.focused, 
.tribe-events .datepicker .year.current:focus, .tribe-events .datepicker .year.current:hover{
     background-color: {$colors['extra_bg_color_07']}
}

.datepicker .datepicker-switch:hover, 
.datepicker .next:hover, 
.datepicker .prev:hover, 
.datepicker tfoot tr th:hover{
     background-color: {$colors['extra_bg_color_07']}
}
.tribe-events .tribe-events-c-top-bar__today-button:hover{
    background-color: {$colors['extra_bg_color_07']};
    color: {$colors['text_dark']};
}
.tribe-events:not(.tribe-common--breakpoint-medium) .tribe-events-c-events-bar,
.tribe-events:not(.tribe-common--breakpoint-medium) .tribe-events-header,
.tribe-events:not(.tribe-common--breakpoint-medium) .tribe-events-calendar-month__day-cell--selected,
.tribe-events:not(.tribe-common--breakpoint-medium) .tribe-events-calendar-month__day-cell--selected:focus,
.tribe-events:not(.tribe-common--breakpoint-medium) .tribe-events-calendar-month__day-cell--selected:hover {
     background-color: {$colors['alter_bg_color']};
}
.tribe-events:not(.tribe-common--breakpoint-medium)  .tribe-events-c-events-bar__search-filters-container,
.tribe-common:not(.tribe-common--breakpoint-medium) .tribe-events-c-events-bar__search .tribe-common-form-control-text__input{
     background-color: {$colors['alter_bg_color']}
}
.tribe-events .tribe-events-c-view-selector__button--active:before,
.tribe-events .tribe-events-c-events-bar__search-button--active:before,
.tribe-events .tribe-events-calendar-month__mobile-events-icon--event{
     background-color: {$colors['extra_bg_color']}
}
.tribe-common .tribe-common-c-btn.tribe-events-c-search__button{
    background-color: {$colors['text_dark']};
    color: {$colors['extra_text']}; 
}
.tribe-common .tribe-common-c-btn.tribe-events-c-search__button:hover{
    background-color: {$colors['extra_bg_color']};
    color: {$colors['extra_text']}; 
}
.tribe-events .tribe-events-calendar-month__day-cell--selected .tribe-events-calendar-month__day-date{
    color: {$colors['text_dark']};
}
.tribe-common .tribe-common-c-btn-border, .tribe-common a.tribe-common-c-btn-border,
.tribe-common--breakpoint-medium.tribe-common .tribe-common-c-btn-border {
	border-color: {$colors['inverse_link']};
	color: {$colors['inverse_link']};
	background-color: transparent !important;
}
.tribe-common .tribe-common-c-btn-border button, .tribe-common a.tribe-common-c-btn-border button,
.tribe-common .tribe-common-c-btn-border button:hover, .tribe-common a.tribe-common-c-btn-border button:hover,
.tribe-common--breakpoint-medium.tribe-common .tribe-common-c-btn-border button,
.tribe-common--breakpoint-medium.tribe-common .tribe-common-c-btn-border button:hover {
	color: {$colors['inverse_link']} !important;
	
}
.tribe-common .tribe-common-c-btn-border:hover, .tribe-common a.tribe-common-c-btn-border:hover,
.tribe-common .tribe-common-c-btn-border:focus, .tribe-common a.tribe-common-c-btn-border:focus,
.tribe-common .tribe-common-c-btn-border:focus-within, .tribe-common a.tribe-common-c-btn-border:focus-within,
.tribe-common--breakpoint-medium.tribe-common .tribe-common-c-btn-border:hover {
	background-color: {$colors['text_hover']};
	border-color: {$colors['text_hover']};
	color: {$colors['inverse_link']};
}
.single-tribe_events #tribe-events-content .tribe-events-event-meta dd {
	color: {$colors['inverse_link']};
}
.tribe-events-single>.tribe_events>:not(.primary,.secondary,.tribe-events-related-events-title,.tribe-related-events) {
	color: {$colors['text']};
}

.tribe-common--breakpoint-medium.tribe-events .tribe-events-calendar-day__event-datetime-featured-text,
.tribe-common--breakpoint-medium.tribe-events .tribe-events-calendar-list__event-datetime-featured-text {
  color: {$colors['text_link']};
}

.tribe-events-calendar-day .tribe-common-c-svgicon,
.tooltipster-base .tribe-common-c-svgicon,
.tribe-events-calendar-month .tribe-common-c-svgicon,
.tribe-events-calendar-list .tribe-common-c-svgicon {
  color: {$colors['text_link']};
}

.tribe-events .tribe-events-calendar-list__event-row--featured .tribe-events-calendar-list__event-date-tag-datetime::after,
.tribe-events .tribe-events-calendar-day__event--featured::after {
  background-color: {$colors['text_link']};
}

.tribe-events .tribe-events-c-messages__message-list-item-link {
    color: {$colors['text_link']};
    border-bottom-color: {$colors['text_link']};
}

.tribe-events-c-messages__message svg {
    color: {$colors['text_link']};
}

.tribe-events-c-events-bar__search-container {
    background-color: {$colors['alter_bg_color']};
}

.tribe-events .datepicker .next .tribe-events-c-top-bar__datepicker-nav-icon-svg path,
.tribe-events .datepicker .prev .tribe-events-c-top-bar__datepicker-nav-icon-svg path {
    fill: {$colors['inverse_text']};
}

.tribe-events .datepicker .datepicker-switch, .tribe-events .datepicker .month, .tribe-events .datepicker .year,
.tribe-events .tribe-events-c-view-selector__list-item-text, .tribe-events .tribe-events-calendar-month__day-date-daynum,
.tribe-common.tribe-events .tribe-common-h7, .tribe-common.tribe-events .tribe-common-h8,
.tribe-common a:not(.tribe-common-anchor--unstyle), .tribe-common a:not(.tribe-common-anchor--unstyle):active,
.tribe-common a:not(.tribe-common-anchor--unstyle):focus, .tribe-common a:not(.tribe-common-anchor--unstyle):hover,
.tribe-common a:not(.tribe-common-anchor--unstyle):visited, .tribe-common .tribe-common-h5, .tribe-common .tribe-common-h6,
.tribe-events .tribe-events-calendar-list__event-datetime, .tribe-common .tribe-common-b2, .tribe-common .tribe-common-b3,
.tribe-events .tribe-events-calendar-day__event-datetime{
    color: {$colors['text_dark']};
}

.tribe-common.tribe-events .tribe-events-c-view-selector--tabs .tribe-events-c-view-selector__list-item--active .tribe-events-c-view-selector__list-item-link:after{
    background-color: {$colors['text_dark']};
}

.tribe-events .tribe-events-calendar-month__header-column-title,
.tribe-events .tribe-events-calendar-month-mobile-events__mobile-event-datetime,
.tribe-events .tribe-events-calendar-list__event-date-tag-weekday{
    color: {$colors['text']};
}

.tribe-events .tribe-events-c-view-selector__list-item-link:focus .tribe-events-c-view-selector__list-item-text,
.tribe-events .tribe-events-c-view-selector__list-item-link:hover .tribe-events-c-view-selector__list-item-text,
.tribe-events-meta-group .tribe-events-single-section-title{
    color: {$colors['text_dark']};
}

CSS;
		}

		return $css;
	}
}

