<?php
/* ThemeREX Updater support functions
------------------------------------------------------------------------------- */

// Theme init priorities:
// 9 - register other filters (for installer, etc.)
if ( ! function_exists( 'giardino_trx_updater_theme_setup9' ) ) {
    add_action( 'after_setup_theme', 'giardino_trx_updater_theme_setup9', 9 );
    function giardino_trx_updater_theme_setup9() {

        if ( is_admin() ) {
            add_filter( 'giardino_filter_tgmpa_required_plugins', 'giardino_trx_updater_tgmpa_required_plugins' );
        }
    }
}

// Filter to add in the required plugins list
if ( ! function_exists( 'giardino_trx_updater_tgmpa_required_plugins' ) ) {
    
    function giardino_trx_updater_tgmpa_required_plugins( $list = array() ) {
        if ( giardino_storage_isset( 'required_plugins', 'trx_updater' ) && giardino_is_theme_activated() ) {
            $path = giardino_get_plugin_source_path( 'plugins/trx_updater/trx_updater.zip' );
            if ( ! empty( $path ) || giardino_get_theme_setting( 'tgmpa_upload' ) ) {
                $list[] = array(
                    'name'     => giardino_storage_get_array( 'required_plugins', 'trx_updater' ),
                    'slug'     => 'trx_updater',
                    'source'   => ! empty( $path ) ? $path : 'upload://trx_updater.zip',
                    'version'  => '2.0.0',
                    'required' => false,
                );
            }
        }
        return $list;
    }
}
// Check if plugin installed and activated
if ( ! function_exists( 'giardino_exists_trx_updater' ) ) {
	function giardino_exists_trx_updater() {
        return defined( 'TRX_UPDATER_VERSION' );
	}
}