<?php
/**
 * Plugin support: Table Reservations
 *
 * @package WordPress
 * @subpackage ThemeREX Addons
 * @since v3.3
 */



// Check if plugin installed and activated
if ( !function_exists( 'trx_addons_exists_table_reservations' ) ) {
    function trx_addons_exists_table_reservations() {
        return defined( 'TREMTR_PLUGIN_DIR' );
    }
}


// One-click import support
//------------------------------------------------------------------------

// Check plugin in the required plugins
if ( !function_exists( 'trx_addons_table_reservations_importer_required_plugins' ) ) {
    if (is_admin()) add_filter( 'trx_addons_filter_importer_required_plugins',	'trx_addons_table_reservations_importer_required_plugins', 10, 2 );
    function trx_addons_table_reservations_importer_required_plugins($not_installed='', $list='') {
        if (strpos($list, 'table_reservations')!==false && !trx_addons_exists_table_reservations() )
            $not_installed .= '<br>' . esc_html__('Table Reservations', 'trx_addons');
        return $not_installed;
    }
}

// Set plugin's specific importer options
if ( !function_exists( 'trx_addons_table_reservations_importer_set_options' ) ) {
    if (is_admin()) add_filter( 'trx_addons_filter_importer_options',	'trx_addons_table_reservations_importer_set_options' );
    function trx_addons_table_reservations_importer_set_options($options=array()) {
        if ( trx_addons_exists_table_reservations() && in_array('table-reservation', $options['required_plugins']) ) {
            $options['additional_options'][] = 'tremtr-settings';
        }
        return $options;
    }
}

// Add checkbox to the one-click importer
if ( !function_exists( 'trx_addons_table_reservations_importer_show_params' ) ) {
    if (is_admin()) add_action( 'trx_addons_action_importer_params',	'trx_addons_table_reservations_importer_show_params', 10, 1 );
    function trx_addons_table_reservations_importer_show_params($importer) {
        if ( trx_addons_exists_table_reservations() && in_array('table-reservation', $importer->options['required_plugins']) ) {
            $importer->show_importer_params(array(
                'slug' => 'table-reservation',
                'title' => esc_html__('Import Table Reservations', 'trx_addons'),
                'part' => 1
            ));
        }
    }
}


?>